package TTXCommon;
#
# This module is a part of Trouble Ticket Express package
# http://www.troubleticketexpress.com
#
# COPYRIGHT: 2002-2005, United Web Coders
# http://www.unitedwebcoders.com
#
# $Revision: 38 $
# $Date: 2005-11-10 11:05:07 +0300 (Thu, 10 Nov 2005) $
#

$TTXCommon::VERSION='2.19';
BEGIN {
  $TTXCommon::REVISION = '$Revision: 38 $';
  if ($TTXCommon::REVISION =~ /(\d+)/) {
    $TTXCommon::REVISION = $1;
  }
};

use strict;
require TTXData;

my %id2name = (
  PND => 'Pending',
  OPN => 'Open',
  WFR => 'Responded',
  '(OPN|WFR)' => 'Active',
  '(PND|OPN|WFR)' => 'Not solved',
  '(OPN|PND)' => 'Hot',
  CLS => 'Solved'
);

# ======================================================================== logit

sub logit {
  my $cfg = TTXData::get('CONFIG');
  my $fn = $cfg->get('basedir')."/ttxlog.txt";
  if (open(TTXLOG, ">>$fn")) {
    flock(TTXLOG,2);
    seek(TTXLOG, 0, 2);
    print TTXLOG time()."|$_[0]\n";
    close TTXLOG;
  }
}
# ======================================================================== tmtxt

sub tmtxt {
  return "-" if !$_[0];
  my $cfg = TTXData::get('CONFIG');
  my $tz = $cfg->get('timezone') * 60;
  my $tm = $_[0] + $tz;
  my ($sec,$min,$hour,$mday,$mon,$year) = gmtime($tm);
  my ($sec1,$min1,$hour1,$mday1,$mon1,$year1) = gmtime(time() + $tz);
  my $date;
  if ($year != $year1) {
    $year += 1900; $year =~ s/^\d\d//;
    $mon++; $mon = "0$mon" if $mon < 10;
    $mday = "0$mday" if $mday < 10;
    $date = "$mon/$mday/$year";
  } elsif ($mon != $mon1 || $mday != $mday1) {
    $mon++; $mon = "0$mon" if $mon < 10;
    $mday = "0$mday" if $mday < 10;
    $date = "$mon/$mday";
  }
  $date .= " " if $date ne undef;
  $hour = "0$hour" if $hour < 10;
  $min = "0$min" if $min < 10;
  $date .= "$hour:$min";
  return $date;
}
# ======================================================================== dbtik

sub dbtik {
  my $cfg = TTXData::get('CONFIG');
  return undef if $cfg eq undef;
  if ($cfg->get('dbmode') eq undef || $cfg->get('dbmode') eq 'plaintext') {
    eval "use TTXFileTickets";
    return TTXFileTickets->new();
  } elsif ($cfg->get('dbmode') eq 'mysql') {
    eval "use TTXMySQLTickets";
    return TTXMySQLTickets->new();
  } elsif ($cfg->get('dbmode') eq 'mssql') {
    eval "use TTXMSSQLTickets";
    return TTXMSSQLTickets->new() if !$@;
  }
  return TTXTickets->new();
}
# ======================================================================= status

sub status {
  return $id2name{$_[0]};
}
# ====================================================================== cleanit

sub cleanit {
  my ($query, $input) = @_;
  my $val = $query->param($input);
  $val =~ s/^\s+//;
  $val =~ s/\s+$//;
  $query->param(-name => $input, -value => $val);
  return $val;
}
# ======================================================================== blank

sub blank {
  my ($cfg, $query, $data) = @_;
  return undef;
}
# ===================================================================== cfldscnt

sub cfldscnt {
  my @list = grep(/^x/, $_[0]->vars());
  my @editable = split(/;/, $_[0]->get('editablefields'));
  my $cnt = 0;
  foreach my $id (@list) {
    my $cid = $_[0]->get($id);
    next if $cid !~ /^\d\d?$/;
    $cid = "c$cid";
    ++$cnt if grep(/^$cid$/, @editable);
  }
  return $cnt;
}


# =================================================================== tickedvars

sub tickedvars {
  my ($cfg, $data) = @_;
  $data->{TICKEDHEIGHT} = 250 + cfldscnt($cfg) * 30;
}

1;
#

