package TTXLogin;
#
# This module is a part of Trouble Ticket Express package
# http://www.troubleticketexpress.com
#
# COPYRIGHT: 2002-2005, United Web Coders
# http://www.unitedwebcoders.com
#
# $Revision: 38 $
# $Date: 2005-11-10 11:05:07 +0300 (Thu, 10 Nov 2005) $
#

$TTXLogin::VERSION='2.19';
BEGIN {
  $TTXLogin::REVISION = '$Revision: 38 $';
  if ($TTXLogin::REVISION =~ /(\d+)/) {
    $TTXLogin::REVISION = $1;
  }
};
use strict;
use TTXCommon;
require TTXUser;
require TTXSession;

# ======================================================================== login

sub login {
  my ($cfg, $query, $data) = @_;
  $data->{PAGEHEADING} = 'Login';
  return undef if !$query->param('dologin');
  if (TTXCommon::cleanit($query, 'login') eq undef) {
    $data->{ERROR_MESSAGE} = 'Missing User ID';
    return undef;
  }
  if (TTXCommon::cleanit($query, 'passwd') eq undef) {
    $data->{ERROR_MESSAGE} = 'Missing Password';
    return undef;
  }
  my $user = TTXUser->new($query->param('login'));
  if ($user eq undef || ($user->get('passwd') eq undef) || ($user->get('passwd') ne $query->param('passwd'))) {
    $data->{ERROR_MESSAGE} = 'Wrong User ID or Password';
    return undef;
  }
  $cfg->set('_USER', $user);
  my $session = TTXSession->new();
  $session->login($query->param('login'));
  $query->param(-name => 'checkupdate', -value => '1');
  $query->param(-name => 'sid', -value => $session->sid());
  if ($query->param('nextcmd') ne undef) {
    $query->param(-name => 'cmd', -value => $query->param('nextcmd'));
    return $query->param('nextcmd');
  }
  return 'helpdesk';
}

1;
#

