package TTXTickEd;
#
# This module is a part of Trouble Ticket Express package
# http://www.troubleticketexpress.com
#
# COPYRIGHT: 2005, United Web Coders
# http://www.unitedwebcoders.com
#
# $Revision: 38 $
# $Date: 2005-11-10 11:05:07 +0300 (Thu, 10 Nov 2005) $
#

$TTXTickEd::VERSION='2.19';
BEGIN {
  $TTXTickEd::REVISION = '$Revision: 38 $';
  if ($TTXTickEd::REVISION =~ /(\d+)/) {
    $TTXTickEd::REVISION = $1;
  }
};
use strict;
use TTXCommon;

# ===================================================================== ticketed
sub ticketed {
  my ($cfg, $query, $data) = @_;
  if ($query->param('isticket')) {
    $query->param(-name => 'isticket', value => '1');
  } else {
    $query->param(-name => 'isticket', value => '0');
  }
  my $tickets = TTXCommon::dbtik();
  if ($tickets eq undef || $tickets->error() ne undef) {
    $data->{ERROR_MESSAGE} = $tickets->errortext();
    return undef;
  }
  my $t = $tickets->ticket(TTXCommon::cleanit($query, 'tid'));
  if ($t eq undef) {
    $data->{ERROR_MESSAGE} = 'Ticket does not exist';
    return 'undef';
  }
  if ($query->param('do')) {
    my $val = TTXCommon::cleanit($query, 'email');
    if ($val !~ /^[0-9A-Za-z._-]+@[0-9A-Za-z_-]+\.[0-9A-Za-z._-]+$/) {
      $data->{ERROR_MESSAGE} .= 'Invalid email address';
    } else {
      $t->{email} = $val;
    }
    $val = TTXCommon::cleanit($query, 'name');
    $t->{name} = $val if $val ne undef;
    $val = TTXCommon::cleanit($query, 'subject');
    $t->{subject} = $val if $val ne undef;
    foreach my $cfld (sort grep(/^c\d\d?$/, $query->param())) {
      $t->{$cfld} = TTXCommon::cleanit($query, $cfld);
    }
    if ($data->{ERROR_MESSAGE} eq undef) {
      $tickets->save();
      $data->{MESSAGE} = 'Ticket updated';
    }
  }
  $data->{TICKET_subject} = $t->{subject};
  $data->{TICKET_email} = $t->{email};
  $data->{TICKET_name} = $t->{name};
  $data->{TICKET_key} = $t->{key};
  my @list = grep(/^x/, $cfg->vars());
  my @editable = split(/;/, $cfg->get('editablefields'));
  my %cflds;
  foreach my $id (@list) {
    my $cid = $cfg->get($id);
    next if $cid !~ /^\d\d?$/;
    $cid = "c$cid";
    if (grep(/^$cid$/, @editable)) {
      $cflds{$cid} = $id;
      $cflds{$cid} =~ s/^x//;
    }
  }
  foreach my $id (sort keys %cflds) {
    $data->{CUSTOMFIELDS} .= "<tr><td align=right><b>$cflds{$id}</b></td>\n".
                            "<td align=left>";
    my $n = $id;
    $n =~ s/^c//;
    my @options = split(/;/, $cfg->get("dropdown$n"));
    if (@options > 0) {
      $data->{CUSTOMFIELDS} .= "<select name=$id>\n";
      my $sel = $query->param('do') ? $query->param($id) : $t->{$id};
      foreach my $opt (@options) {
        my $val = $opt; $val =~ s/"/&quot;/g;
        $data->{CUSTOMFIELDS} .= "<option value=\"$val\"";
        if ($opt eq $sel) {
          $data->{CUSTOMFIELDS} .= ' selected';
        }
        $opt =~ s/</&lt;/g;
        $data->{CUSTOMFIELDS} .= ">$opt</option>\n";
      }
      $data->{CUSTOMFIELDS} .= "</select>\n";
    } else {
      my $val = $query->param('do') ? $query->param($id) : $t->{$id};
      $val =~ s/"/&quot;/g;
      $data->{CUSTOMFIELDS} .= "<input type=text size=30 name=$id value=\"$val\">";
    }
    $data->{CUSTOMFIELDS} .= "</td></tr>\n";
  }
  return undef;
}

1;
#
