package TTXUpgrade;
#
# This module is a part of Trouble Ticket Express package
# http://www.troubleticketexpress.com
#
# COPYRIGHT: 2005, United Web Coders
# http://www.unitedwebcoders.com
#
# $Revision: 38 $
# $Date: 2005-11-10 11:05:07 +0300 (Thu, 10 Nov 2005) $
#

$TTXUpgrade::VERSION='2.191';
BEGIN {
  $TTXUpgrade::REVISION = '$Revision: 38 $';
  if ($TTXUpgrade::REVISION =~ /(\d+)/) {
    $TTXUpgrade::REVISION = $1;
  }
};
use strict;

my %upgradepath = (
  '2.182' => { ver => '2.19', code => \&upgrade219 },
  '2.19' => { ver => '2.191', code => \&upgrade2191 }
);

# ====================================================================== upgrade

sub upgrade {
  my $cfg = $_[0];
  my $v = $cfg->get('ttx.version');
  if ($v eq undef) {
    if (-f  $cfg->get('basedir'). "/templates/ticketed.html") {
      $v = '2.182';
    }
  }
  for (my $ver = $upgradepath{$v}; $ver ne undef ; $ver = $upgradepath{$ver}->{ver}) {
    my $err = &{$ver->{code}}($cfg);
    if ($err ne undef) {
      return $err;
    }
    $cfg->set('ttx.version', $ver->{ver});
    $cfg->save();
  }
  return undef;
}

# =================================================================== upgrade219

sub upgrade219 {
  my $cfg = $_[0];
  my $fn = $cfg->get('basedir'). "/templates/header.shtml";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  my $buff = join('', <F>);
  if ($buff !~ /\btd\.txt\s+\{/) {
    my $addthis = <<EOT;
td.txt  {
  padding-right: 4pt;
  padding-left: 4pt;
  padding-top: 2pt;
  padding-bottom: 1pt;
  border-width:1px;
  border-style:solid;
  border-top-width:0;
  border-bottom-width:0;
  border-right-width:0;
  font-size : 8pt;
  border-color: #FFF;
  color: #666;
  text-align: left;
}
EOT
    $buff =~ s/<\/style>/$addthis\n<\/style>/;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  $fn = $cfg->get('basedir'). "/templates/helpdesk.html";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  $buff = join('', <F>);
  if ($buff =~ /<\s*input\s+type="?hidden"?\s+name="?qwindow"?\s+value="?\(%INPUT_qwindow%\)"?\s*>/) {
    $buff =~ s/<\s*input\s+type="?hidden"?\s+name="?qwindow"?\s+value="?\(%INPUT_qwindow%\)"?\s*>//;
    my $addthis = <<EOT;
        <tr>
          <td align=left>
            <span class=sm>
            Show <input type=text size=3 class=sm name=qwindow value=(%INPUT_qwindow%)> tickets per page.
            Include abstracts <input type=checkbox class=sm name=abstract value=1(%CHECKABSTRACT%)>
            </span>
          </td>
          <td align=right>
            <input type=submit value=Search>&nbsp;<input type=submit name=reset value="Show all">
          </td>
        </tr>
EOT
    my $findthis = '<tr>\s*<td[^>]*><input\s+type="?submit"?[^>]*>[^<]*<input\s+type="?submit"?[^>]*>[^<]*</td>[^<]*</tr>';
    $buff =~ s/$findthis/$addthis\n/i;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  $fn = $cfg->get('basedir'). "/templates/ticket.html";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  $buff = join('', <F>);
  if ($buff =~ /width=700,\s*height=300,\s*resizable/) {
    $buff =~ s/width=700,\s*height=300,\s*resizable/width=700,height=360,resizable/;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  $fn = $cfg->get('basedir'). "/templates/answerlib.html";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  $buff = join('', <F>);
  if ($buff !~ /showcat/) {
    $buff =~ s/-->\s*<\/style>/.lbl { font-size: 9pt; font-weight: 700;}-->\n<\/style>/;
    my $addthis = <<EOT;
<script language=Javascript>
<!--
function showcat(id) {
  location.href='(%ENV_SCRIPT_NAME%)?cmd=answerlib&sid=(%INPUT_sid%)&style=(%INPUT_style%)&cat='+escape(id);
  return false;
}
// -->
</script>
</head>
EOT
    $buff =~ s/<\/head>/$addthis/i;
    $buff =~ s/\(%ANSWERLIBMSG%\)\s*<br>/(%ANSWERLIBMSG%)\n/;
    $addthis = <<EOT;
				  <table cellpadding=1 cellspacing=1>
					  <tr>
						  <td>
                      <select name=cat size=1 OnChange="return showcat(this[this.selectedIndex].value);">
(%CATSELECTOR%)
						</select>
							</td>
						</tr>
						<tr>
						  <td>
                        <select name=answer size=10 OnChange="return showanswer(this[this.selectedIndex].value);">
(%ANSWERSELECTOR%)
                        </select>
							</td>
						</tr>
					</table>
EOT
    $buff =~ s/<select\s+name="?answer"?[^<]*<\/select>/$addthis/i;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  $fn = $cfg->get('basedir'). "/templates/newanswer.html";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  $buff = join('', <F>);
  if ($buff !~ /CATSELECTOR/) {
    $buff =~ s/-->\s*<\/style>/.lbl { font-size: 9pt; font-weight: 700;}-->\n<\/style>/;
    my $addthis = <<EOT;
                <td colspan=2></td>
        </tr>
        <tr>
                <td colspan=2></td>
        </tr>
        <tr>
          <td align=left class=lbl>Select existing category</td>
          <td align=left>
			<select name=cat OnChange="if (this[this.selectedIndex].value) {document.editor.catnew.value = ''}; return false;">
		  	(%CATSELECTOR%)
		  	</select>
		  </td>
        </tr>
        <tr>
                <td align=left class=lbl>or define new one: </td>
                <td align=left><input type=text size=30 name=catnew value="(%INPUT_catnew%)"></td>
        </tr>
        <tr>
                <td colspan=2 valign=top class=lbl>Answer</td>
EOT
    $buff =~ s/<td[^<>]*>\s*Answer\s*<\/td>/$addthis/i;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  $fn = $cfg->get('basedir'). "/templates/delanswer.html";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  $buff = join('', <F>);
  if ($buff !~ /\.lbl/) {
    $buff =~ s/-->\s*<\/style>/.lbl { font-size: 9pt; font-weight: 700;}-->\n<\/style>/;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  eval "use TTXLayout";
  if ($@ ne undef) {
    $cfg->set('fltrcols', 'text|subject|oper|status|id');
    $cfg->save();
  } else {
    $cfg->set('fltrcols', 'text|'.$cfg->get('fltrcols'));
  }
  return undef;
}
# =================================================================== upgrade219

sub upgrade2191 {
  my $cfg = $_[0];
  my $fn = $cfg->get('basedir'). "/templates/helpdesk.html";
  return "File $fn does not exist" if ! -f $fn;
  return "File $fn is not writable" if ! -w $fn;
  return "Can't open file $fn" if !open(F, "+<$fn");
  flock(F,2);
  my $buff = join('', <F>);
  if ($buff =~ /<\s*input\s+type="?hidden"?\s+name="?qwindow"?\s+value="?\(%INPUT_qwindow%\)"?\s*>/) {
    $buff =~ s/<\s*input\s+type="?hidden"?\s+name="?qwindow"?\s+value="?\(%INPUT_qwindow%\)"?\s*>//;
    seek(F,0,0);
    print F $buff;
    truncate(F, tell(F));
    close(F);
  }
  return undef;
}
1;
#

